package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Account;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: AccountType
// UnionValue: LiteIdentity

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("LiteIdentity")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class LiteIdentity implements Account {
	public final AccountType type = AccountType.LITE_IDENTITY;
	private Url url;
	private long creditBalance;
	private long lastUsedOn;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public LiteIdentity url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public LiteIdentity url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public long getCreditBalance() {
	    return creditBalance;
	}
	public void setCreditBalance(final long value) {
	    this.creditBalance = value;
	}

	public LiteIdentity creditBalance(final long value) {
	    setCreditBalance(value);
	    return this;
	}
	public long getLastUsedOn() {
	    return lastUsedOn;
	}
	public void setLastUsedOn(final long value) {
	    this.lastUsedOn = value;
	}

	public LiteIdentity lastUsedOn(final long value) {
	    setLastUsedOn(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(this.creditBalance == 0)) {
            marshaller.writeUint(3, this.creditBalance);
        }
        if (!(this.lastUsedOn == 0)) {
            marshaller.writeUint(4, this.lastUsedOn);
        }
        return marshaller.array();
    }
}
